if exists (select 1 from sysobjects where name = 'cm_flush_int')
  drop procedure cm_flush_int;

if exists (select 1 from sysobjects where name = 'cm_flush_str')
  drop procedure cm_flush_str;

create procedure cm_flush_int(in cacheName varchar(100), in cacheKey integer)
  url 'http://cm-flush$system:flush-77@wateas4:80/rest/protected/text/sql.CacheManager.flush'
  type 'http:post';

create procedure cm_flush_str(in cacheName varchar(100), in cacheKey varchar(100))
  url 'http://cm-flush$system:flush-77@wateas4:80/rest/protected/text/sql.CacheManager.flush'
  type 'http:post';

if exists (select 1 from sysobjects where name = 'td_C_customer')
  drop trigger td_C_customer;

if exists (select 1 from sysobjects where name = 'tu_C_customer')
  drop trigger tu_C_customer;

if exists (select 1 from sysobjects where name = 'td_C_customerinventory')
  drop trigger td_C_customerinventory;

if exists (select 1 from sysobjects where name = 'ti_C_customerinventory')
  drop trigger ti_C_customerinventory;

if exists (select 1 from sysobjects where name = 'tu_C_customerinventory')
  drop trigger tu_C_customerinventory;

if exists (select 1 from sysobjects where name = 'tu_C_parts')
  drop trigger tu_C_parts;

if exists (select 1 from sysobjects where name = 'tu_C_site')
  drop trigger tu_C_site;

if exists (select 1 from sysobjects where name = 'tu_C_supplier')
  drop trigger tu_C_supplier;

if exists (select 1 from sysobjects where name = 'tu_M_parts')
  drop trigger tu_M_parts;

if exists (select 1 from sysobjects where name = 'tu_M_bom')
  drop trigger tu_M_bom;

if exists (select 1 from sysobjects where name = 'td_M_inventory')
  drop trigger td_M_inventory;

if exists (select 1 from sysobjects where name = 'tu_M_inventory')
  drop trigger tu_M_inventory;

if exists (select 1 from sysobjects where name = 'tu_M_largeorder')
  drop trigger tu_M_largeorder;

if exists (select 1 from sysobjects where name = 'tu_M_workorder')
  drop trigger tu_M_workorder;

if exists (select 1 from sysobjects where name = 'tu_O_item')
  drop trigger tu_O_item;

if exists (select 1 from sysobjects where name = 'td_O_orders')
  drop trigger td_O_orders;

if exists (select 1 from sysobjects where name = 'ti_O_orders')
  drop trigger ti_O_orders;

if exists (select 1 from sysobjects where name = 'tu_O_orders')
  drop trigger tu_O_orders;

if exists (select 1 from sysobjects where name = 'td_O_orderline')
  drop trigger td_O_orderline;

if exists (select 1 from sysobjects where name = 'ti_O_orderline')
  drop trigger ti_O_orderline;

if exists (select 1 from sysobjects where name = 'tu_O_orderline')
  drop trigger tu_O_orderline;

if exists (select 1 from sysobjects where name = 'td_S_component')
  drop trigger td_S_component;

if exists (select 1 from sysobjects where name = 'tu_S_component')
  drop trigger tu_S_component;

if exists (select 1 from sysobjects where name = 'tu_S_purchase_order')
  drop trigger tu_S_purchase_order;

if exists (select 1 from sysobjects where name = 'tu_S_purchase_orderline')
  drop trigger tu_S_purchase_orderline;

if exists (select 1 from sysobjects where name = 'tu_S_site')
  drop trigger tu_S_site;

if exists (select 1 from sysobjects where name = 'tu_S_supplier')
  drop trigger tu_S_supplier;

if exists (select 1 from sysobjects where name = 'tu_S_supp_component')
  drop trigger tu_S_supp_component;

create trigger td_C_customer
  before delete on C_customer
  referencing old as this
  for each row
begin
  call cm_flush_int('specjappserver.corp.CustomerEnt', this.c_id);
end;

create trigger tu_C_customer
  before update on C_customer
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
  call cm_flush_int('specjappserver.corp.CustomerEnt', this.c_id);
end;

create trigger td_C_customerinventory
  before delete on C_customerinventory
  referencing old as this
  for each row
begin
  update C_customer set version = version + 1
    where c_id = this.ci_customerid;
end;

create trigger ti_C_customerinventory
  before insert on C_customerinventory
  referencing new as this
  for each row
begin
  update C_customer set version = version + 1
    where c_id = this.ci_customerid;
end;

create trigger tu_C_customerinventory
  before update on C_customerinventory
  referencing new as this
  for each row
begin
  update C_customer set version = version + 1
    where c_id = this.ci_customerid;
  set this.version = this.version + 1;
end;

create trigger tu_C_parts
  before update on C_parts
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;

create trigger tu_C_site
  before update on C_site
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;

create trigger tu_C_supplier
  before update on C_supplier
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;

create trigger tu_M_parts
  before update on M_parts
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
  update ref_tv set version = version + 1;
end;

create trigger tu_M_bom
  before update on M_bom
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
  update ref_tv set version = version + 1;
end;

create trigger td_M_inventory
  before delete on M_inventory
  referencing old as this
  for each row
begin
  call cm_flush_str('specjappserver.mfg.InventoryEnt', this.in_p_id);
end;

create trigger tu_M_inventory
  before update on M_inventory
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
  call cm_flush_str('specjappserver.mfg.InventoryEnt', this.in_p_id);
end;

create trigger tu_M_largeorder
  before update on M_largeorder
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;

create trigger tu_M_workorder
  before update on M_workorder
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;

create trigger tu_O_item
  before update on O_item
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
  update ref_tv set version = version + 1;
end;

create trigger td_O_orders
  before delete on O_orders
  referencing old as this
  for each row
begin
  update C_customer set o_version = o_version + 1
    where c_id = this.o_c_id;
  call cm_flush_int('specjappserver.orders.OrderEnt', this.o_id);
end;

create trigger ti_O_orders
  before insert on O_orders
  referencing new as this
  for each row
begin
  update C_customer set o_version = o_version + 1
    where c_id = this.o_c_id;
end;

create trigger tu_O_orders
  before update on O_orders
  referencing new as this
  for each row
begin
  update C_customer set o_version = o_version + 1
    where c_id = this.o_c_id;
  set this.version = this.version + 1;
  call cm_flush_int('specjappserver.orders.OrderEnt', this.o_id);
end;

create trigger td_O_orderline
  before delete on O_orderline
  referencing old as this
  for each row
begin
  update O_orders set version = version + 1
    where o_id = this.ol_o_id;
end;

create trigger ti_O_orderline
  before insert on O_orderline
  referencing new as this
  for each row
begin
  update O_orders set version = version + 1
    where o_id = this.ol_o_id;
end;

create trigger tu_O_orderline
  before update on O_orderline
  referencing new as this
  for each row
begin
  update O_orders set version = version + 1
    where o_id = this.ol_o_id;
  set this.version = this.version + 1;
end;

create trigger td_S_component
  before delete on S_component
  referencing old as this
  for each row
begin
  call cm_flush_str('specjappserver.supplier.SComponentEnt', this.comp_id);
end;

create trigger tu_S_component
  before update on S_component
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
  call cm_flush_str('specjappserver.supplier.SComponentEnt', this.comp_id);
end;

create trigger tu_S_purchase_order
  before update on S_purchase_order
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;

create trigger tu_S_purchase_orderline
  before update on S_purchase_orderline
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;

create trigger tu_S_site
  before update on S_site
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;

create trigger tu_S_supp_component
  before update on S_supp_component
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;

create trigger tu_S_supplier
  before update on S_supplier
  referencing new as this
  for each row
begin
  set this.version = this.version + 1;
end;
